﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule.MonthViewSingle;
using System.Drawing;
using Infragistics.Win.UltraWinSchedule;
using System.Diagnostics;

namespace _85124
{
    class MyCreation:IUIElementCreationFilter
    {

        Dictionary<Appointment, SingleDayAppointmentUIElement> DayApps = new Dictionary<Appointment, SingleDayAppointmentUIElement>();
        private Infragistics.Win.UltraWinSchedule.UltraMonthViewSingle ultraMonthViewSingle1;

        public MyCreation(Infragistics.Win.UltraWinSchedule.UltraMonthViewSingle ultraMonthViewSingle1)
        {
            // TODO: Complete member initialization
            this.ultraMonthViewSingle1 = ultraMonthViewSingle1;
            ultraMonthViewSingle1.DrawFilter = new MyDraw(ref DayApps);
        }
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {

            DayNumberUIElement dayHeader = parent as DayNumberUIElement;
            if (dayHeader != null)
            {
                DayUIElement day = dayHeader.Parent as DayUIElement;
                if (day.Day.Appointments.Count == 0)
                    return false;
                Point AppAreaLocation = dayHeader.Rect.Location;
                AppAreaLocation.Offset(0, dayHeader.Rect.Height + 2);
                Size AppArea = new Size(dayHeader.Rect.Width, day.Rect.Height - dayHeader.Rect.Height - 2);
                int h = AppArea.Height;
                int w = AppArea.Width;
                int n = day.Day.Appointments.Count;
                double Ah = Math.Sqrt(h * h / n);
                double Aw; //= Math.Sqrt(w * w / n);

                if (h % Ah >= 0.3 * Ah)
                {
                    int AhOpt = h / (int)Ah;
                    Ah = h / (AhOpt + 1);
                }

                Ah = Ah < 10 ? 10 : Ah;
                Ah = Ah > 20 ? 20 : Ah;

                Aw = Ah * w / h;
                if (w % Aw >= 0.4 * Aw)
                {
                    int AwOpt = w / (int)Aw;
                    Aw = w / (AwOpt + 1);
                }

                Aw = Aw < 10 ? 10 : Aw;
                Aw = Aw > w ? w : Aw;

                

                Size appSize = new Size((int)Aw, (int)Ah);

                Debug.WriteLine(appSize);

                Point appLocation = AppAreaLocation;
                List<SingleDayAppointmentUIElement> newAppUI = new List<SingleDayAppointmentUIElement>();
                foreach (Appointment app in day.Day.Appointments)
                {
                    SingleDayAppointmentUIElement appUI = new SingleDayAppointmentUIElement(day, app);
                    appUI.Rect = new Rectangle(appLocation, appSize);
                    
                    if (DayApps.ContainsKey(app))
                        DayApps[app] = appUI;
                    else
                        DayApps.Add(app, appUI);
                    newAppUI.Add(appUI);
                    if (appLocation.X + appSize.Width * 2 > AppAreaLocation.X + AppArea.Width)
                    {
                        appLocation = new Point(AppAreaLocation.X, appLocation.Y + appSize.Height);
                    }
                    else
                    {
                        appLocation.Offset(appSize.Width, 0);
                    }

                }
                day.ChildElements.AddRange(newAppUI);
                return false;
            }

           
            AppointmentSelectedUIElement sel = parent as AppointmentSelectedUIElement;
            if (sel != null)
                return true;

            return false;
            
        }

        #endregion
    }

    class MyDraw : IUIElementDrawFilter
    {
        Dictionary<Appointment, SingleDayAppointmentUIElement> DayApps;
        public MyDraw(ref Dictionary<Appointment, SingleDayAppointmentUIElement> DayApps)
        {
            this.DayApps = DayApps;
        }
        #region IUIElementDrawFilter Members

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            DrawPhase phase = DrawPhase.None;
            if (drawParams.Element is SingleDayAppointmentUIElement)
            {
                SingleDayAppointmentUIElement app = drawParams.Element as SingleDayAppointmentUIElement;
                if (app.Appointment != null && !DayApps[app.Appointment].Equals(app))
                    phase=  DrawPhase.BeforeDrawElement;
                
            }
            return phase;
        }

        #endregion
    }

}
